
var localize={
    
locals: {
    'en': {
    occ: "OC Chat",
    oci: "OC Info",
    hotn: "Hot News",	//space at the beginning
    hls: "Headlines",	//space at the beginning
    fiec:"'Finance&Economics",
	ocm: "OC Mall",
	toat: "Tourist",
	adti: "Admission&Ticket",
	hobo: "Hotel Booking",
	myst: "My Study",
	occu: "OC Culture",
	news: "News",
	mymu: "My Music",
	rali: "Ranking List",
	recom: "Recommended",
	ocf: "OC Forum",
	entc: "Eng Teach",
	vipl: "Video Play",
	toho: "Today HotNews",
	tvdr: "TV Drama",
	movie: "Movie",
	myca: "My Calendar",
	charity: "Charities",
	chpr: "Charity Proj",
	chne: "Charity News",
	remittance: "Remittance",
	supererogation: "Merits",
	feedback: "Feedback",
	mebo: "Msg Board",
	more: "More",
	abus: "About us",
	seho: "Contact Us",
	verup: "Version",
	tesu: "Tech Support",
	share: "Share",
	shme: "Share Message",
	simi: "Sina Microblog",
	temi: "Tencent Microblog",
	dial: "Dialing up",
	home: "Home",
	information: "Infomation",
	forum: "Forum",
	back: "Back",
    vipcard:"VipCard",
    },
    'cn': {
    occ: "侨友交流",
    oci: "华侨资讯",
    hotn: "热点",	//space at the beginning
    hls: "头条",	//space at the beginning
    fiec:"'财经",
    ocm: "华侨商城",
    toat: "旅游胜地",
    adti: "景点门票",
    hobo: "酒店订购",
    myst: "我的书房",
    occu: "华侨文化",
    news: "动态",
    mymu: "我的音乐",
    rali: "排行榜",
    recom: "推荐歌曲",
    ocf: "华侨论坛",
    entc: "英语教育",
    vipl: "视频播放",
    toho: "今日热点",
    tvdr: "电视剧",
    movie: "电影",
    myca: "我的日历",
    charity: "公益慈善",
    chpr: "慈善项目",
    chne: "慈善新闻",
    remittance: "在线汇款",
    supererogation: "功德",
    feedback: "跟踪回馈",
    mebo: "留言板",
    more: "更多",
    abus: "关于我们",
    seho: "服务热线",
    verup: "版本更新",
    tesu: "技术支持",
    share: "分享",
    shme: "短信分享",
    simi: "新浪微博",
    temi: "腾讯微博",
    dial: "一键拨号",
    home: "首页",
    information: "资讯",
    forum: "论坛",
    back: "返回",
    vipcard:"领取会员卡",
    },
    'zh': {
    occ: "僑友交流",
    oci: "華僑資訊",
    hotn: "熱點",	//space at the beginning
    hls: "頭條",	//space at the beginning
    fiec:"財經",
    ocm: "華僑商城",
    toat: "旅遊勝地",
    adti: "景點門票",
    hobo: "酒店訂購",
    myst: "我的書房",
    occu: "華僑文化",
    news: "動態",
    mymu: "我的音樂",
    rali: "排行榜",
    recom: "推薦歌曲",
    ocf: "華僑論壇",
    entc: "英語教育",
    vipl: "視頻播放",
    toho: "今日熱點",
    tvdr: "電視劇",
    movie: "電影",
    myca: "我的日歷",
    charity: "公益慈善",
    chpr: "慈善項目",
    chne: "慈善新聞",
    remittance: "在線匯款",
    supererogation: "功德",
    feedback: "跟蹤回饋",
    mebo: "留言板",
    more: "更多",
    abus: "關於我們",
    seho: "服務熱線",
    verup: "版本更新",
    tesu: "技術支持",
    share: "分享",
    shme: "短信分享",
    simi: "新浪微博",
    temi: "騰訊微博",
    dial: "一鍵撥號",
    home: "首頁",
    information: "資訊",
    forum: "論壇",
    back: "返回",
    vipcard:"領取會員卡",
    }
},
    /* DO NOT CHANGE UNDER THIS */
lang: '',
start: function(lang){
    lang=lang.toLowerCase();
    this.lang=lang;
    var langs=this.locals;
    $('.lang').each(function(){
                    var txt=$(this).data('lang');
                    var to=$(this).data('lang-to');
                    if(txt!==''&&typeof langs[lang]!=='undefined'&&typeof langs[lang][txt]!=='undefined'){
                    switch(to){
                    case 'text':
                    $(this).text(langs[lang][txt]);
                    break;
                    case 'placeholder':
                    case 'alt':
                    case 'title':
                    $(this).attr(to, langs[lang][txt]);
                    break;
                    case 'html':
                    default:
                    $(this).html(langs[lang][txt]);
                    break;
                    }
                    }
                    });
},
get: function(code){
    var langs=this.locals, lang=this.lang;
    if(code!==''&&typeof langs[lang]!=='undefined'&&typeof langs[lang][code]!=='undefined'){
        return langs[lang][code];
    }else{
        return '';
    }
}};
//localize.start(lang);
//try{
//	var userLang = navigator.language||navigator.userLanguage;
//	var language=userLang.split("-");
//	localize.start(lang);
//}catch(err){
//	localize.start('en');
//}
