String.prototype.replaceAll = function( token, newToken, ignoreCase ) {
    var _token;
    var str = this + "";
    var i = -1;

    if ( typeof token === "string" ) {

        if ( ignoreCase ) {

            _token = token.toLowerCase();

            while( (
                i = str.toLowerCase().indexOf(
                    token, i >= 0 ? i + newToken.length : 0
                ) ) !== -1
            ) {
                str = str.substring( 0, i ) +
                    newToken +
                    str.substring( i + token.length );
            }

        } else {
            return this.split( token ).join( newToken );
        }

    }
return str;
};
function objnopropcount(obj){
	if(obj.hasOwnProperty('__count__')){
		return obj.__count__;
	}else{
		var count = 0;
		for (var i in obj){
			if (obj.hasOwnProperty(i)) {
				count ++;
			}
		}
		return count;
	}
}
//此处定义浏览器扩展
function addwidwxid(wid,wxid){
	window.localStorage.setItem("wid",wid);
	window.localStorage.setItem("wxid",wxid);
}
function delwidwxid(wid,wxid){
	window.localStorage.clear();
}

function toupdate(startup){
	if(navigator.connection.type == Connection.NONE){
		toast('无法连接网络');
		return;
	}
	window.couldupdate = true;
	$('.alltopfixd').show();
	if(!startup){
		loadin('updateing');
	}else{
		toast('更新中...');
		setTimeout(function(){
			loadin('updateing');
		},88);
	}
	//加载最新list
	$.getScript(yyuc_updatepath+'list.js').done(function(){
		if(!yyuc_filelist){
			return toupdatefail(1);
		}
		window.yyuc_filelist = yyuc_filelist;
		//加载referlist
		$.getScript(rooturl+'referlist.js').done(function(){			
			if(!mqq_filelist){
				return toupdatefail(2);
			}
			if(mqq_filelist.version==yyuc_filelist.version){
				$('.alltopfixd').hide();
				loadout('updateing');
				if(!startup){
					toast('最新版本，无需更新');
				}else{
					setTimeout(function(){
						window.istaping = false;
						//显示页面的浏览器
						//alert($(window.mqqpcss).find('.llq:visible').size());
						$(window.mqqpcss).find('.llq:visible').each(function(){
							var src = $(this).find('.llqrel').attr('osrc');
							if(src.indexOf('http')!==0){
								src = window.basepath + src;
							}
							yyuc.openview({url:src,x:$(this).offset().left,y:$(this).offset().top,width:$(this).width(),height:$(this).height(),uuid:($(window.mqqpcss).attr('uuid')+$(this).attr('uuid'))});
						});
					},500);
				}			
				return;
			}
			//加载oldlist
			$.getScript(rooturl+'oldlist.js').done(function(){				
				if(!old_filelist){
					return toupdatefail(3);
				}
				var needreppics = [];
				var needdownpics = [];
				var needrepmeds = {};
				var zxpics = yyuc_filelist.img;
				var oldpics = old_filelist.img;
				var mypics = mqq_filelist.img;
				var zxmeds = yyuc_filelist.med;
				var oldmeds = old_filelist.med;
				var mymeds = mqq_filelist.med;
				for(var s in zxpics){
					if(!oldpics[s]){
						needreppics[needreppics.length] = s;
						if(!mypics[s]){
							needdownpics[needdownpics.length] = s;
						}
					}
				}
				for(var s in zxmeds){
					if(!oldmeds[s]){
						needrepmeds[s] = zxmeds[s];
					}
				}
				var needdownpags = [];
				var zxpags = yyuc_filelist.pag;
				var mypags = mqq_filelist.pag;				
				for(var s in zxpags){
					if(!mypags[s]){
						needdownpags[needdownpags.length] = s;
					}else if(mypags[s].md5 != zxpags[s].md5){
						needdownpags[needdownpags.length] = s;
					}
				}
				window.firsrinitzgsygs = needdownpics.length + needdownpags.length;
				loadout('updateing');
				$('#preparediv').show();
				updatedownload(needdownpics,needdownpags,needreppics,needrepmeds);
			}).fail(toupdatefail);
		}).fail(toupdatefail);
	}).fail(toupdatefail);
}
function updatedownload(di,dp,rp,mp){
	if(!window.couldupdate){
		return;
	}
	var sygs = di.length + dp.length;
	var bfb = parseInt((window.firsrinitzgsygs-sygs)/window.firsrinitzgsygs*100);
	if(!bfb){
		bfb = 0;
	}
	toast('更新进度：'+bfb+'%');
	if(di.length>0){
		var fileTransfer = new FileTransfer();
		var uri = encodeURI(yyuc_updatepath+"med/"+di[0]);
		var filepath = window.rootpath.replace('file://','')+'med/'+di[0];
		fileTransfer.download(uri,filepath,
		    function(entry) {
				di.shift();
				updatedownload(di,dp,rp,mp);
		    },
		    function(error) {
		        return toupdatefail(4);
		    },
		    true
		);
	}else if(dp.length>0){
		$.ajax({
			  url: yyuc_updatepath+'pag/'+dp[0]+'.html',
			  cache: false,
			  success: function(m){
				//替换图片路径
				for(var i=0;i<rp.length;i++){
					m = m.replaceAll('med/'+rp[i],rooturl+'med/'+rp[i]);
				}
				//替换音视频路径
				for (var nn in mp){
					m = m.replaceAll('med/'+nn,mp[nn]);
				}
				$('#preparediv').find('.phoneview').empty().html(m);
				var cangoto = 0;
				var gotonext = function(){
					cangoto--;
					$('#preparediv').find('img').each(function(){
						//缓存所有图片
						if($(this).height()==0 && cangoto==-1){
							cangoto = 8;
						}
					});
					if(cangoto>0){
						setTimeout(gotonext,50);
					}else{
						//先对数据进行位置调整		
						fq_adjuestposition($('#preparediv'),function(){
							m = $('#preparediv').find('.phoneview').html();						
							setPhyPage(dp[0],m,function(){
								dp.shift();
								updatedownload(di,dp,rp,mp);
							},function(){
								alert('程序页面缓存设置错误');
							});
						});
					}
				};
				gotonext();	
				
				
			  },
			  error: function(){
				  return toupdatefail(4);
			  }
		});
	}else{
		setPhyPage('referlist.js','mqq_filelist = '+JSON.stringify(window.yyuc_filelist)+';',function(){
			toast('更新成功');
			loadout('updateing');
			$('#preparediv').hide();
			$('#preparediv').find('.phoneview').empty();
			$('.alltopfixd').hide();
			gotopage('index',null,'d');		
		},function(){
			alert('程序页面缓存设置错误');
		});
				
	}
	
}

function toupdatefail(type){
	var emsg = type==1?'请检查网络链接':'网络连接异常或文件遭到破坏';
	toast('更新失败:'+emsg);
	loadout('updateing');
	$('#preparediv').find('.phoneview').empty();
	$('#preparediv').hide();
	$('.alltopfixd').hide();
	window.couldupdate = false;
	return false;
}

function exitapp(){
	if(window.isandroid){
		if($("#back").length > 0){
			fq_addqevents($("#back"));
			}
		else
			{
			navigator.notification.confirm('按“确定”退出程序!',function(button){
				if(button==1) {navigator.app.exitApp();}
		    },'确定要退出程序吗?','确定,取消');
			}
	}else{
		toast('请点击主菜单键退出');
	}
	return false;
}

function init(){
	if(!deviceok){
		setTimeout(function(){
			init();
		},200);
		return;
	}
	window.onerror = function(msg, url, line){
 		//alert(msg);
 		//alert(url);
 		//alert(line);
	};
	
	
	
	//定义按下后退键的动作
	document.addEventListener("backbutton", exitapp, false);
	//按下菜单键
	document.addEventListener("menubutton", mainmenu, false);
	//缓存清理
	document.addEventListener("pause", yyuc.clear, false);
	document.addEventListener("resume", function(){
		loadin();
		if(isandroid){			
			//安卓推送
			setpushmsg();
		}
		setTimeout(loadout,10);
	}, false);
		
	window.isandroid = (/android/gi).test(navigator.appVersion);
	window.isoldandroid = (/android 2/gi).test(navigator.appVersion);
	window.isiphone = (/iphone/gi).test(navigator.appVersion);
	window.isipad = (/ipad/gi).test(navigator.appVersion);
	window.isios = window.isiphone || window.isipad;
	window.phonewidth = window.innerWidth;
	window.phoneheight = window.innerHeight;
	
    window.basepath = location.href.substr(0, location.href.lastIndexOf('/')+1);
    
    window.fileTransfer = new FileTransfer();
	$('.mainmenu').width(phonewidth).css('top',phoneheight+'px');
	$('.alltopback').width(phonewidth);
	$('.leftlistmenu').height(phoneheight).width(150);
	$('.alltopfixd,.phonebody,.phoneview,.mqqmain,.mqqmainv,#preparediv').width(phonewidth).height(phoneheight);
	//pv_transmoveX($('#phonebak')[0],phonewidth);
	//正式初始化开始
	getPhyPage('version',function(m){
		if(parseInt(m)>=parseInt(yyuc_appversion)){
			getextrooturl(function(url,path){
				window.rooturl = url;
				window.rootpath = path;
				getPhyPage('pushtime',function(m){
					window.pushtime = m;
					gogogo();
				});
			});			
		}else{
			//应用被重装过新版本
			initdata();
		}			
	},initdata);	
}

//取得外部存放跟路径url、
function getextrooturl(fun,fail){
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getDirectory('zzbapp'+yyuc_appid, {create: true, exclusive: false}, function(fileEntry){
			fileSystem.root.getDirectory('zzbapp'+yyuc_appid+'/med', {create: true, exclusive: false}, function(fileEntry2){
				fun(fileEntry.toURL()+'/',fileEntry.fullPath+'/');
			}, fail);
		}, fail);
	}, fail);
}

//初始化数据
function initdata(){
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getDirectory('zzbapp'+yyuc_appid, {create: true, exclusive: false}, function(fileEntry){
			fileEntry.removeRecursively();
			getextrooturl(function(url,path){
				window.rooturl = url;
				window.rootpath = path;
				$.get('list.js',function(m){
					setPhyPage('referlist.js',m.replace('yyuc_filelist','mqq_filelist'),function(){
						//更新的参照此文件没有的页面则下载 此文件没有的图片则下载(下载图片时先看是否已经下载过) 对新下载的页面进行图片src替换 此时替换的依据是 oldlist
						setPhyPage('oldlist.js',m.replace('yyuc_filelist','old_filelist'),function(){	
							$.get('add.js',function(mm){
								setPhyPage('add.js',mm,function(){
									setPhyPage('version',yyuc_appversion+'',function(){
										setPhyPage('pushtime','0',function(){
											setPhyPage('pushmsg','0',function(){
												window.pushtime = '0';
												gogogo();
											});
										});
									});
								});
							});
						});	
					});		
				});	
			});
		},$.noop);	
	},$.noop);
}

//读取文件内容
function getPhyPage(path,succ,fail){
	var path = 'zzbapp'+yyuc_appid+'/'+path;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getFile(path, null, function(fileEntry){
			fileEntry.file(function (file) {
			    var reader = new FileReader();
			    reader.onloadend = function(evt) {
			    	succ(evt.target.result);
			    };
			    reader.readAsText(file);
			}, fail);
		}, fail);
	}, fail);
}
//写入文件内容
function setPhyPage(path,txt,succ,fail){
	var path = 'zzbapp'+yyuc_appid+'/'+path;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getFile(path, {create: true, exclusive: false}, function(fileEntry){
			fileEntry.createWriter(function (writer) {
				if(succ){
					writer.onwriteend = function(evt){
						succ(evt);
			        };
				}			 	
		        writer.write(txt);
			}, fail);
		}, fail);
	}, fail);
}
