function objnopropcount(obj){
	if(obj.hasOwnProperty('__count__')){
		return obj.__count__;
	}else{
		var count = 0;
		for (var i in obj){
			if (obj.hasOwnProperty(i)) {
				count ++;
			}
		}
		return count;
	}
}

function exitapp(){
	if(window.isandroid){
		navigator.notification.confirm('按“确定”退出程序!',function(button){
			if(button==1) {navigator.app.exitApp();}
	    },'确定要退出程序吗?','确定,取消');
	}	
	return false;
}
function init(){
	if(!deviceok){
		setTimeout(function(){
			init();
		},200);
		return;
	}
	
	
	
	
	//定义按下后退键的动作
	document.addEventListener("backbutton", exitapp, false);
	//按下菜单键
	document.addEventListener("menubutton", mainmenu, false);
	//缓存清理
	document.addEventListener("pause", yyuc.clear, false);
	document.addEventListener("resume", function(){
		loadin();
		setTimeout(loadout,200);
	}, false);
		
	window.isandroid = (/android/gi).test(navigator.appVersion);
	window.isoldandroid = (/android 2/gi).test(navigator.appVersion);
	window.isiphone = (/iphone|ipad/gi).test(navigator.appVersion);
	window.phonewidth = window.innerWidth;
	window.phoneheight = window.innerHeight;
	
    window.basepath = location.href.substr(0, location.href.lastIndexOf('/')+1);
    
    window.fileTransfer = new FileTransfer();
	$('.mainmenu').width(phonewidth).css('top',phoneheight+'px');
	$('.alltopback').width(phonewidth);
	$('.leftlistmenu').height(phoneheight).width(150);
	$('.alltopfixd,.phonebody,.phoneview,.mqqmain,.mqqmainv').width(phonewidth).height(phoneheight);
	//pv_transmoveX($('#phonebak')[0],phonewidth);
	//正式初始化开始
	getextrooturl(function(url,path){
		window.rooturl = url;
		window.rootpath = path;
		getPhyPage('version',function(m){
			if(parseInt(m)>=parseInt(yyuc_appversion)){
				gogogo();
			}else{
				//应用被重装过
				initdata();
			}
			
		},initdata);
	});
	
}

//取得外部存放跟路径url、
function getextrooturl(fun,fail){
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getDirectory('zzbapp'+yyuc_appid, {create: true, exclusive: false}, function(fileEntry){
			fileSystem.root.getDirectory('zzbapp'+yyuc_appid+'/med', {create: true, exclusive: false}, function(fileEntry2){
				fun(fileEntry.toURL()+'/',fileEntry.fullPath+'/');
			}, fail);
		}, fail);
	}, fail);
}

//初始化数据
function initdata(){
	//显示加载页
	if(!window.initing){
		$('.alltopfixd').html('<img src="css/app/zzb.png" style="width:100%;height:100%">').show();
		window.initing = true;
		setTimeout(initdata,888);
		return;		
	}
	
	
	$.getScript('list.js',function(){
		navigator.splashscreen.hide();
		window.pags = yyuc_filelist.pag;
		window.firsrinitzgsygs = objnopropcount(window.pags);
		transhtml(function(){
			$.ajax({
				url:'add.js',
				dataType:'text',
				success:function(m){
					setPhyPage('add.js',m,function(){
						//写入版本信息
						setPhyPage('version',yyuc_appversion+'',function(){
							gogogo();
						});
					});
				},
				error:function(a,b,c){
					alert('附加脚本错误！');
				}
			});
		});
	});
}


//html解析 加快速度改成异步解析
function transhtml(fun){
	var sygs = objnopropcount(window.pags);
	var bfb = parseInt((window.firsrinitzgsygs-sygs)/window.firsrinitzgsygs*100);
	if(!bfb){
		bfb = 0;
	}
	toast('加载进度：'+bfb+'%');
	if(sygs<=0){
		fun();
		return;
	}
	for(var p in window.pags){
		//对每个pag进行解析
		delete window.pags[p];
		$.get('pag/'+p+'.html', function(m){
			//先对数据进行位置调整
			$('.phonebak').find('.phoneview').html(m);			
			fq_adjuestposition($('.phonebak'),function(){
				m = $('.phonebak').find('.phoneview').html();
				$('.phonebak').find('.phoneview').empty();
				setPhyPage(p,m,function(){
					transhtml(fun);
				},function(){
					alert('程序页面缓存设置错误');
				});
			});						
		});	
		return;
	}
	
}


//读取文件内容
function getPhyPage(path,succ,fail){
	var path = 'zzbapp'+yyuc_appid+'/'+path;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getFile(path, null, function(fileEntry){
			fileEntry.file(function (file) {
			    var reader = new FileReader();
			    reader.onloadend = function(evt) {
			    	succ(evt.target.result);
			    };
			    reader.readAsText(file);
			}, fail);
		}, fail);
	}, fail);
}
//写入文件内容
function setPhyPage(path,txt,succ,fail){
	var path = 'zzbapp'+yyuc_appid+'/'+path;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getFile(path, {create: true, exclusive: false}, function(fileEntry){
			fileEntry.createWriter(function (writer) {
				if(succ){
					writer.onwriteend = function(evt){
						succ(evt);
			        };
				}			 	
		        writer.write(txt);
			}, fail);
		}, fail);
	}, fail);
}
