Object.prototype.count = (
    Object.prototype.hasOwnProperty('__count__')
  ) ? function () {
    return this.__count__;
  } : function () {
    var count = 0;
    for (var i in this) if (this.hasOwnProperty(i)) {
      count ++;
    }
    return count;
  };
function init(){
	if(!deviceok){
		setTimeout(function(){
			init();
		},200);
		return;
	}
	//正式初始化开始
	$('#lprediv').text('0');
	getextrooturl(function(url,path){
		yyuc_rooturl = url;
		yyuc_rootpath = path;
		getPhyPage('version.root',function(m){
			if(parseFloat(m)>=parseFloat(yyuc_appversion)){
				location.href="init.html";
			}else{
				//应用被重装过
				initdata();
			}
			
		},initdata);
	});
	
}

//取得外部存放跟路径url、
function getextrooturl(fun,fail){
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getDirectory('zzbapp'+yyuc_appid, {create: true, exclusive: false}, function(fileEntry){
			fun(fileEntry.toURL()+'/',fileEntry.fullPath+'/');
		}, fail);
	}, fail);
}

//初始化数据
function initdata(){
	$.getScript('js/list.js',function(){
		window.pags = yyuc_filelist.pag;
		transhtml(function(){
			window.imgs = yyuc_filelist.img;
			getimgs(function(){
				//下载附加js
				var fileTransfer = new FileTransfer();
				fileTransfer.download(
					encodeURI('js/add.js'),
				    yyuc_rootpath+'add.js',
				    function(entry) {
						setPhyPage('version.root',yyuc_filelist.version,function(){
							$('#lprediv').text('100');
							window.localStorage.setItem("rooturl", yyuc_rooturl);
							window.localStorage.setItem("rootpath", yyuc_rootpath);
							location.href="init.html";
						},function(){
							alert('版本更新错误');
						});						
				    },
				    function(error) {
				    	alert('动态脚本加载错误。');
				    },
				    false
				);
			});
		});
	});
}
//获得静态文件
function getimgs(fun){
	if(window.imgs.count()<=0){
		fun();
		return;
	}
	for(var p in window.imgs){
		delete window.imgs[p];
		var fileTransfer = new FileTransfer();
		fileTransfer.download(
			encodeURI('img/'+p),
		    yyuc_rootpath+p,
		    function(entry) {
		    	getimgs(fun);
		    },
		    function(error) {
		    	alert('静态文件存储错误。');
		    },
		    false
		);
		return;
	}
}

//html解析
function transhtml(fun){
	if(window.pags.count()<=0){
		fun();
		return;
	}
	for(var p in window.pags){
		//对每个pag进行解析
		delete window.pags[p];
		$.get('pag/'+p, function(m){
			if(window.jm){
				window.jm.remove();
				delete window.jm;
			}
			window.jm = $('<div>'+m+'</div>');
			window.jm.find('img').each(function(){
				if($.trim($(this).attr('src'))!=''){
					$(this).attr('src',yyuc_rooturl+$(this).attr('src'));
				}
				//isload 存的本就是动态取得的 所以无需设置
			});
			//存外部地址
			setPhyPage(p,window.jm.html(),function(){
				transhtml(fun);
			},function(){
				alert('程序页面缓存设置错误');
			});
		});	
		return;
	}
	
}

//读取文件内容
function getPhyPage(path,succ,fail){
	var path = 'zzbapp'+yyuc_appid+'/'+path;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getFile(path, null, function(fileEntry){
			fileEntry.file(function (file) {
			    var reader = new FileReader();
			    reader.onloadend = function(evt) {
			    	succ(evt.target.result);
			    };
			    reader.readAsText(file);
			}, fail);
		}, fail);
	}, fail);
}
//写入文件内容
function setPhyPage(path,txt,succ,fail){
	var path = 'zzbapp'+yyuc_appid+'/'+path;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
		fileSystem.root.getFile(path, {create: true, exclusive: false}, function(fileEntry){
			fileEntry.createWriter(function (writer) {
				writer.onwriteend = function(evt) { 
					succ(evt);
		        };
		        writer.write(txt);
			}, fail);
		}, fail);
	}, fail);
}